
import java.io.*;
import java.util.ArrayList;

public class TestPeano
{
    public static void main(String[] args){
		System.out.println("Hello world !!!");
		
		TestPeano t = new TestPeano();
		Peano p1 = new Succ(new Succ(new Zero()));
		Peano p2 = new Succ(new Succ(new Succ(new Zero())));
		System.out.println(p1);
		System.out.println(p2);
		System.out.println(p2.add(p1));
		
		System.out.println(t.ofInt(715).add(t.ofInt(1934)).toInt() + " = " + (715+1934));
		
		System.out.println("Start benchmark...");
		
		int j;
		for (int i=0; i<2000; i++){
			j = t.ofInt(i*2).add(t.ofInt(i*3)).toInt();
		}
		
		System.out.println("Finished !");
		
		
    }

    public Peano ofInt(int n){
		if(n == 0)
		    return new Zero();
		else
		    return new Succ(ofInt(n - 1));
    }
}

class Peano {
    public Peano addSucc(Succ s){ return null; }
    public Peano add(Peano p){ return null; }
    public int toInt(){ return -1; }
    public String toString(){ return "Error"; }
}

class Zero extends Peano {
    public Peano addSucc(Succ s){
    	return s;
    }
    public Peano add(Peano p){
    	return p;
    }
    public int toInt(){
    	return 0;
    }
    public String toString(){
    	return "Zero";
    }
}

class Succ extends Peano {
    final private Peano p;
    public Succ(Peano p){
    	this.p = p;
    }
    public Peano addSucc(Succ s){
    	return new Succ(new Succ(s.p.add(this.p)));
    }
    
    public Peano add(Peano p){
    	return p.addSucc(this);
    }
    
    public Peano getP(){
    	return p;
    }
    
    public int toInt(){
    	return 1 + p.toInt();
    }
    public String toString(){
    	return "Succ(" + p + ")";
    }
}

